#ifndef ImageProvider_h
#define ImageProvider_h

#include "config.h"

#include <vector>
#include <string>

class SimpleImage;

class ImageProvider
{
public:
	virtual SimpleImage* getImage();
};

class SynchronizedObject
{
public:
	SynchronizedObject();
	~SynchronizedObject();

protected:
	void lock();
	void unlock();

private:
	HANDLE hLock;
};

class RandomImageProvider : public ImageProvider, protected SynchronizedObject
{
public:
	RandomImageProvider(FileList flist);

	virtual SimpleImage* getImage();

private:
	void randomizeImages();
	void addDirectory(std::string dir);

	typedef std::vector<std::string> FileVec;
	typedef FileVec::iterator FileIt;

	FileVec files;
	int iCurFile;
	int iCount;
};

#endif

