#ifndef LoadThread_h
#define LoadThread_h

#include "iSlideshow.h"
#include "config.h"
#include "Slide.h"

class PrefetchTexture;
class Slide;
class TexturePool;
class SimpleImage;
class ImageProvider;

class LoadThread
{
public:
	// Create file loading thread using specified list, loading mSlides into cache
	LoadThread(ImageProvider* ip, int mSlides, TexturePool* p, HDC dc);
	~LoadThread();

	// Start/stop thread
	void start();
	void stop();

	// Return slide from thread
	Slide* getNextSlide();

	int slidesReady();

	void addSlide(SimpleImage* im, bool forceCenter = false);

	SlideFactory& getSlideFactory() { return slideFactory; }

private:
	static DWORD WINAPI SlideThread(LPVOID lt);
	DWORD CheckerSlideThread();
	DWORD SlideThreadLocal();
	DWORD FileThread();

	HDC hdc;

	HANDLE slideLock;
	HANDLE slideLoadSem;
	HANDLE slideFreeSem;
	HANDLE thread;
	DWORD threadId;
	int maxSlides;

	SlideFactory slideFactory;

	// FileList fileList;
	ImageProvider* imgProvider;

	// std::list<PrefetchTexture*> slides;
	std::list<Slide*> slides;
	bool bStopThread;

	TexturePool* pool;
};

#endif
