#ifndef PrefetchTexture_h
#define PrefetchTexture_h

#include <GL/gl.h>
#include <vector>

class SimpleImage;
class TexturePool;

// OpenGL texture which can be prepared in one thread before 
// used in the main thread
class PrefetchTexture
{
public:
	PrefetchTexture(SimpleImage*, TexturePool* p);
	~PrefetchTexture();
	void Draw();
	void Load();

private:
	int w, h;
	std::vector<SimpleImage*> images;
	GLuint texid;
	TexturePool* pool;

	void CreateMipmap(SimpleImage* im);
};

#endif
