#ifndef config_h
#define config_h

#include <list>
#include <map>
#include <string>
#include <vector>

#include <GL/gl.h>

typedef TCHAR FileName[MAX_PATH];
typedef std::vector<std::string> FileList;
typedef FileList::iterator FileIt;

// Handles configuration and display of config dialog
class SlideshowConfig
{
public:
	SlideshowConfig();
	~SlideshowConfig();

	void readRegistry();
	void writeRegistry();

	FileList fileList;
	int dPriority;
	int openConfigBox(HWND parent);

	bool multimon;
	int backRed, backGreen, backBlue;

	GLsizei textureDimensions();
	GLint textureDepth();
	int secondsPerImage;

private:
	void setDefaults();
	void initControls(HWND hdlg);
	void removeDirectories(HWND hdlg);

	static BOOL CALLBACK aboutProc(HWND hdlg, UINT msg, WPARAM wpm, LPARAM lpm);
	static BOOL ScreenSaverConfigureDialogGlobal(HWND hdlg, UINT msg, WPARAM wpm, LPARAM lpm);
	BOOL ScreenSaverConfigureDialog(HWND hdlg, UINT msg, WPARAM wpm, LPARAM lpm);

	HWND hwnd;
	typedef std::map<HWND,SlideshowConfig*> HwndMap;
	typedef HwndMap::iterator HwndMapIterator;
	static HwndMap hwndMap;

	int texDim;
	int texDepth;
};

extern SlideshowConfig config;

#endif
