#ifndef display_h
#define display_h

#include <memory>
#include "TexturePool.h"
#include "LoadThread.h"
#include "util.h"

void displaySaver();
void initGL();
void initSlides();
void loadImages();

class Slide;
class Loader;

class Slideshow
{
public:
	Slideshow(HWND wnd, SimpleImage* screenShot);
	~Slideshow();
	void display();

	HWND getHWND() { return hwnd; }

private:
	void initSaver(SimpleImage* screenShot);

	double curTime;

	double frameTime;

	HWND hwnd;
	HDC hdc;
	HGLRC hglrc;
	std::auto_ptr<LoadThread> loader;
	std::auto_ptr<TexturePool> pool;

	Slide* mainSlide;
	Slide* newSlide;
};

#endif