// iSlideshow.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "../Savergl/savergl.h"
#include "iSlideshow.h"
#include "TexturePool.h"

#include <time.h>
#include <regstr.h>
#include <commctrl.h>
#include <shellapi.h>
#include <shlobj.h>
#include <stdio.h>
#include "resource.h"
#include "display.h"
#include "config.h"

#include <algorithm>

static int readyToDraw = 0;

typedef std::list<Slideshow*> SlideshowList;
typedef SlideshowList::iterator SlideshowIterator;
static SlideshowList shows;

void draw(){
	for (SlideshowIterator it = shows.begin(); it != shows.end(); ++it)
		(*it)->display();
}


void IdleProc(){
	Sleep(10);
	if(readyToDraw && !checkingPassword)
		draw();
	else
		for (SlideshowIterator it = shows.begin(); it != shows.end(); ++it)
			ShowWindow((*it)->getHWND(), SW_HIDE);

}




LONG ScreenSaverProc(HWND hwnd, UINT msg, WPARAM wpm, LPARAM lpm){
	// static unsigned long threadID;

	switch(msg){
	case WM_CREATE:
	{
		config.readRegistry();
		/*switch(dPriority){
		case 0:
			SetThreadPriority((void *)threadID, THREAD_PRIORITY_LOWEST);
			break;
		case 1:
			SetThreadPriority((void *)threadID, THREAD_PRIORITY_BELOW_NORMAL);
			break;
		case 2:
			SetThreadPriority((void *)threadID, THREAD_PRIORITY_NORMAL);
		}*/
		LPCREATESTRUCT pcs = (LPCREATESTRUCT)lpm;
		SimpleImage* im = (SimpleImage*)pcs->lpCreateParams;
		Slideshow* ss = new Slideshow(hwnd, im);
		shows.push_back(ss);
		readyToDraw = 1;
	}
		break;
	case WM_DESTROY:
		readyToDraw = 0;

		for (SlideshowIterator it = shows.begin(); it != shows.end(); ++it)
			delete *it;

		shows.clear();

		break;
	}
	return DefScreenSaverProc(hwnd, msg, wpm, lpm);
}

